;VIA_BIOS	EQU 1

$ShowSymb MACRO s
	IFDEF VIA_BIOS
	  IFNB <s>
	    mov ax,0E00h+s
	  ELSE
	    mov ah,0Eh
	  ENDIF
	  int 10h
	ELSE
	  push dx
	  IFNB <s>
	    mov dl,s
	  ELSE
	    mov dl,al
	  ENDIF
	  mov ah,2
	  int 21h
	  pop dx
	ENDIF
ENDM

$ShowEAX:
	push eax
	shr eax,16
	call $ShowAX
	pop eax
$ShowAX:				; AX  HEX ଠ
	push ax
	shr ax,8
	call $ShowAL
	pop ax
$ShowAL:
	pusha
	push ax
	shr al,4
	call $ShowHex
	pop ax
	call $ShowHex
	popa
	retn
$ShowHex:			;  HEX-  AL
	and al,15
	add al,48
	cmp al,58
	jc $1
	add al,7
$1:
	$ShowSymb
	retn

$ShowLong:
	pushad
	or eax,eax
	jns $11
	pushad
	mov al,'-'
	$ShowSymb
	popad
	neg eax
$11:
	mov cx,10
	mov di,offset $numlong
$2:	
	cmp eax,cs:[di]
	jnc $5
	add di,4
	loop $2
	$ShowSymb 48
	jmp short $3
$5:
	mov ebx,cs:[di]
	call $4
	add di,4
	loop $5
$3:	popad
	retn
	
$4:
	xor edx,edx
	div ebx
	add al,48
	$ShowSymb
	mov eax,edx
	retn

$ShowDec:				; AX  DEC ଠ
	pusha
	mov cx,5
	mov di,offset $numbers
$7:	
	cmp ax,cs:[di]
	jnc $6
	inc di
	inc di
	loop $7
	$ShowSymb 48
	jmp short $8
$6:
	xor dx,dx
$10:
	mov bx,cs:[di]
	call $9
	inc di
	inc di
	loop $10
$8:	
	popa
	retn
$9:
	xor dx,dx
	div bx
	add al,48
	$ShowSymb
	mov ax,dx
	retn

$numlong	dword 1000000000,100000000,10000000,1000000,100000
		dword 10000,1000,100,10,1
	
$numbers	word 10000,1000,100,10,1

$Next_Line:
	pusha
	$ShowSymb 13
	$ShowSymb 10
	popa
	retn

