GenSerial:

	mov ecx,1
@gs4:	mov ebx,46
@gs3:	mov ax,13
	call Power
	cmp ax,2
	jnz @gs1

	mov ax,18
	call Power
	cmp ax,7
	jnz @gs1
	
	mov ax,7
	call Power
	cmp ax,18
	jnz @gs1

	mov ax,12
	call Power
	cmp ax,23
	jz @gs2
@gs1:
	inc bx
	cmp bx,100
	jnz @gs3
	inc cx
	jmp @gs4	
@gs2:
	mov ax,cx
	aam
	add ax,03030h
	xchg ah,al
	mov First,ax
	mov ax,bx
	aam
	add ax,03030h
	xchg ah,al
	mov Second,ax
	retn
;
;  ஥   ⥯ 32- ᥫ  .
;  -    ⥯ N 筮  N,  log2(N)
;  権, -  ᫥  ᫥ 
;  㬭,    १ (㬠  ९) 
;  - ⮫ ᫥   8- ᫠ (sic!)
;  १ ᮯ. ᯮ  PhrowzyCrow 諨 ࢮ
;  ࠭祭,   㡥訬 ࠧ 訫  ᫥.
;
;  Fast raising for 32-bit integers by modul.
;  First, it is enought log2(N) iterations instead of N.
;  Second, we should calculate remainder by module at every iteration
;  nor at result - think about overflow. Third, only last lamaz 
;  calculate 8-bit integers (sic!) via FPU. Kewl PhrowzyCrow-membaz 
;  are managed without first restriction but violated two others
;  points.
;

Power:	push esi
	push edi
	push cx
	movzx esi,ax
	mov edi,1
@pw3:	jcxz @pw1
	test cx,1
	jz @pw2
	mov eax,edi
	mul esi
	div ebx
	mov edi,edx
@pw2:	mov eax,esi
	mul esi
	div ebx
	mov esi,edx
	shr cx,1
	jmp @pw3
@pw1:	mov eax,edi
	pop cx
	pop edi
	pop esi
	retn
